/**
 *  \file MaximumTripletScore.h    \brief Define TripletScore.
 *
 *  This file is generated by a script (tools/make-container).
 *  Do not edit directly.
 *
 *  Copyright 2007-2010 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_MAXIMUM_TRIPLET_SCORE_H
#define IMPCONTAINER_MAXIMUM_TRIPLET_SCORE_H

#include "container_config.h"
#include <IMP/TripletScore.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Evaluate the maximum n triplet scores of the passed set of TripletScores
/** Each of the set of TripletScores is evaluated and the sum of the
    minimum n is returned.
*/
class IMPCONTAINEREXPORT MaximumTripletScore : public TripletScore
{
  TripletScores scores_;
  unsigned int n_;
public:
  MaximumTripletScore(const TripletScoresTemp &scores,
                       unsigned int n=1,
                       std::string name="TripletScore %1%");
  IMP_TRIPLET_SCORE(MaximumTripletScore);
};

IMPCONTAINER_END_NAMESPACE

#endif  /* IMPCONTAINER_MAXIMUM_TRIPLET_SCORE_H */
