/**
 *  \file MinimumPairScore.h    \brief Define PairScore.
 *
 *  This file is generated by a script (tools/make-container).
 *  Do not edit directly.
 *
 *  Copyright 2007-2010 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_MINIMUM_PAIR_SCORE_H
#define IMPCONTAINER_MINIMUM_PAIR_SCORE_H

#include "container_config.h"
#include <IMP/PairScore.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Evaluate the minimum n pair scores of the passed set of PairScores
/** Each of the set of PairScores is evaluated and the sum of the
    minimum n is returned.
*/
class IMPCONTAINEREXPORT MinimumPairScore : public PairScore
{
  PairScores scores_;
  unsigned int n_;
public:
  MinimumPairScore(const PairScoresTemp &scores,
                       unsigned int n=1,
                       std::string name="PairScore %1%");
  IMP_PAIR_SCORE(MinimumPairScore);
};

IMPCONTAINER_END_NAMESPACE

#endif  /* IMPCONTAINER_MINIMUM_PAIR_SCORE_H */
